routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\App;
use Barryvdh\DomPDF\Facade\PDF;
use App\Http\Controllers\ClienteController;
use App\Http\Controllers\ProductoController;
use App\Http\Controllers\BoletaController;
use App\Http\Controllers\AlumnoMateriaController;
use App\Http\Controllers\ImprimirController;
use App\Http\Controllers\ImprimirPdfController;

use App\Models\Boleta;
use App\Models\Cliente;
use App\Models\Producto;
// use App\Models\Boleta;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/sistema_cotizaciones',function(){
    return view('sistema_cotizaciones.clientes.index');
});

Route::get('/administracion',function(){
    return view('sistema_cotizaciones.administracion.index');
})->name('administracion');

Route::get('/crear_usuario',function(){
    return view('sistema_cotizaciones.clientes.create');
})->name('crear_usuario');

Route::get('/boletas',function(){
$boletas = Boleta::all();
// return $boletas;
return view('boletas',compact('boletas'));
});

Route::get('/clientes',function(){
    $clientes = Cliente::all();
    return $clientes;
});

 Route::resource('/clientes',ClienteController::class);

 Route::resource('/productos',ProductoController::class);

 Route::resource('/cotizaciones',BoletaController::class);
//

Route::resource('/alumno_materia',AlumnoMateriaController::class);


Route::get("imprimir_pdf", function (Request $request) {
    $dompdf = App::make("dompdf.wrapper");
    $dompdf->loadView("ejemplo", [
        "nombre" => "Luis Cabrera Benito",
    ]);
    // return $dompdf->stream();
    // return $dompdf->download("mi_archivo.pdf");//Descargar
    $dompdf->save("archivos_pdf/mi_archivo.pdf"); //guardar en carpeta public
    return "PDF guardado";//redirect o save
    // combinadolos
    // return PDF::loadFile(public_path().'/myfile.html')->save('/path-to/my_stored_file.pdf')->stream('download.pdf');
});

// Route::get('/imprimir', GeneradorController::class)-name('print');

Route::get('/pdf',function(){

    $today = "1982";
    $pdf = PDF::loadView('ejemplo2', compact('today'));
    // return $pdf->download('ejemplo2.pdf');
    return $pdf->stream('ejemplo2.pdf');

    // $pdf = PDF::loadView('pdf.invoice', $data);
    // return $pdf->download('invoice.pdf');
});

Route::resource('/imprimir_cotizacion',ImprimirController::class);

Route::get('/mostrarPdf',function(){
$pdf = new ImprimirPdfController();
return $pdf->mostrarPdf($id = 3);
})->name('mostrarPdf');

app/Models/Producto.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Producto extends Model
{
    use HasFactory;

    public $timestamps=false;

    protected $table = 'productos';

    protected $fillable = ['descripcion','precio','stock','estado','imagen'];

    public function boletas(){
        return $this->belongsToMany(Boleta::class,'boleta_producto')->withPivot('cantidad');
    }
}

app/Http/Controllers/ProductoController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Producto;

class ProductoController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $productos = Producto::all();
        return view('sistema_cotizaciones.productos.index',compact('productos'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('sistema_cotizaciones.productos.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $nombre_producto = $request->file('archivo')->getClientOriginalName();
        // Producto::create($request->all());
        // $extension = $request->file('avatar')->extension();
        Producto::create(['descripcion'=>$request->descripcion,'precio'=>$request->precio,'stock'=>$request->stock,'estado'=>$request->estado,'imagen'=>$nombre_producto]);
        $request->file('archivo')->storeAs('public',$nombre_producto);       
        // $path = $request->file('avatar')->storeAs('avatars', $request->user()->id);
        
        // $request->file('archivo')->store('public',$nombre_producto);
        // $request->file('archivo')->store('public');
        // $request->file('archivo')->store('public/otracarpeta');
        return redirect()->route('productos.index');        
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $producto = Producto::find($id);
        // return $producto;
        return view('sistema_cotizaciones.productos.edit',compact('producto'));
        // return view('sistema_cotizaciones.productos.edit',compact('producto'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        Producto::find($id)->update($request->all());
        return redirect()->route('productos.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
       $producto = Producto::find($id);

       if($producto->estado == 0){
        $status = 1;
       }
       elseif($producto->estado == 1){
        $status = 0;
       }

       $producto->update(['estado' => $status]);
       return redirect()->route('productos.index');

    }
}

resources/views/sistema_cotizaciones/productos/create.blade.php
@extends('sistema_cotizaciones.main.app2')
@section('content')
<div class="container-fluid">
    <h1>Crear Producto</h1>
    <hr>

<form method="POST" action="{{ route('productos.store') }}"  role="form" accept-charset="UTF-8" enctype="multipart/form-data">
{{ csrf_field() }}
<div>
    <label for="descripcion">Descripción:</label>
    <input type="text" class="form form-control" name="descripcion" placeholder="Descripción"/>
</div>
<br>
<div>
    <label for="precio">Precio:</label>
    <input type="text" class="form form-control" name="precio" placeholder="Precio"/>
</div>
<br>
<div>
    <label for="stock">Stock:</label>
    <input type="text" class="form form-control" name="stock" placeholder="Stock"/>
</div>
<br>
<div>
    <label for="archivo"><b>Archivo: </b></label>
    <input type="file" name="archivo" required class="form form-control">
</div>
    <br>
<div>
    <label for="estado">Estado Producto:</label>
    <select name="estado" class="form form-control">
        <option value="1">1 - Activo</option>
        <option value="0">0 - DisContinuado</option>
    </select>
</div>
<br>
<div>
<input type="submit"  value="Guardar" class="btn btn-primary form-control"/>
    <!-- <button type="submit" class="btn btn-primary form-control">Enviar</button> -->
</div>

</form>
</div>
@endsection

resources/views/sistema_cotizaciones/productos/edit.blade.php
@extends('sistema_cotizaciones.main.app2')
@section('content')
<div class="container-fluid">
    <h1>Editar Producto</h1>
    <hr>

<form method="POST" action="{{route('productos.update',$producto->id)}}"  role="form">
{{ csrf_field() }}
@method('PUT')
<div>
    <label for="descripcion">Descripción:</label>
    <input type="text" class="form form-control" name="descripcion" placeholder="Descripción" value="{{$producto->descripcion}}"/>
</div>

<div>
    <label for="precio">Precio:</label>
    <input type="text" class="form form-control" name="precio" placeholder="Precio" value="{{$producto->precio}}"/>
</div>

<div>
    <label for="stock">Stock:</label>
    <input type="text" class="form form-control" name="stock" placeholder="Stock" value="{{$producto->stock}}"/>
</div>

<div>
    <label for="estado">Estado Producto:</label>
    <select name="estado" class="form form-control">
        @if($producto->estado == 0)
        <option value="0">0 - DisContinuado</option>
        <option value="1">1 - Activo</option>
        @elseif($producto->estado == 1)
        <option value="1">1 - Activo</option>
        <option value="0">0 - DisContinuado</option>
        @endif
    </select>
</div>
<br>
<div>
<input type="submit"  value="Guardar" class="btn btn-primary form-control"/>
    <!-- <button type="submit" class="btn btn-primary form-control">Enviar</button> -->
</div>

</form>
</div>
@endsection

resources/views/sistema_cotizaciones/productos/index.blade.php
@extends('sistema_cotizaciones.main.app2')
@section('content')
<div class="container-fluid bg-light" style="border:solid 1px #aaa;height:auto;margin-top:5px;margin-left:-10px;">
<br>
<!-- <div class="row"><div class="col col-lg-10"> -->
    <h2>Listado de Productos</h2>
<!-- </div> -->
   <!-- <div class="col col-lg-2"><a href="" class="btn btn-primary text-light">+ Nuevo</a></div></div> -->
    <hr>
    <br>
    <table id="tblProductos" class="table table-hover table-striped text-center">
        <thead>
            <tr>
                <th>#</th>
                <th>DESCRIPCIÓN</th>
                <th>PRECIO</th>
                <th>STOCK</th>
                <th>ESTADO</th>
                <th></th>
                <th></th>
            </tr>
        </thead>
        <tbody>
        @php
            $i = 0
        @endphp
    @foreach($productos as $prod)
    <tr>
        <td>{{++$i}}</td>
        <td>{{$prod->descripcion}}</td>
        <td>{{$prod->precio}}</td>
        <td>{{$prod->stock}}</td>

        @if($prod->estado == 0)
        <td><p class="text-danger">{{'DisContinuado'}}</p></td>
        @elseif($prod->estado == 1)
        <td><p class="text-success">{{'Activo'}}</p></td>
        @endif
        <td><a href="{{route('productos.edit', $prod->id)}}" class="btn btn-warning text-light">Editar</a></td>
        <td>
            <form method="POST" action="{{route('productos.destroy', $prod->id)}}" role="form">
                {{csrf_field()}}
                <input name="_method" type="hidden" value="DELETE">

                @if($prod->estado == 0)
                <button type="submit" class="btn btn-success text-light">{{'Habilitar'}}</button>
                @elseif($prod->estado == 1)
                <button type="submit" class="btn btn-danger text-light">{{'DesHabilitar'}} </button>
                 @endif

            </form>
        </td>
    </tr>
    @endforeach
</tbody>
    </table>

</div>
@endsection